<?php
include("properties.php");

dsncommand();

function dsncommand(){
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	$u=array();
	$u[] = new xmlrpcval("1", "int");

	$f=new xmlrpcmsg('getDSN.getDSN',$u);
	// send request
	$r=&$c->send($f);
	
	// check response for errors, and take appropriate action
	// draw the dots into the image
	if (!$r->faultCode()) {
	  $v=$r->value();
	  $max=$v->arraysize();
	  for($i=0; $i<$max; $i++) {
			// change the data from the XmlRpc-Request into new vars
			$rec=$v->arraymem($i);
			$DSNID_temp		  = $rec->structmem("DSNID");
			$DSNID[$i] 		  = $DSNID_temp->scalarval();
	  }
	} else {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}

	if(isset($_POST['_send_command'])){
		if (isset($_POST["all"])){
			if (($_POST["command"]!=" --write a command--") && ($_POST["command"]!="" )){
				$v=array();
				$v[] = new xmlrpcval("all", "string");
				$v[] = new xmlrpcval($_POST["command"], "string");  
				$f=new xmlrpcmsg('dsnCommand.dsnCommand', $v);
			}
			else if ($_POST["precommand"]!="--or select a command!--"){
				$v=array();
				$v[] = new xmlrpcval("all", "string"); 
				$v[] = new xmlrpcval($_POST["precommand"], "string"); 
				$f=new xmlrpcmsg('dsnCommand.dsnCommand', $v);
			}
			
			$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
			$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
			//$c->setDebug(2);
			$r=$c->send($f);
			
			if ($r->faultCode()) {
			  print "An error occurred:<pre>";
			  print "Code: " . htmlspecialchars($r->faultCode()) .
				"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
			}
			else{
				$v = $r->value(); 
			}
		}
		elseif (isset($_POST["GUInode"])){
			if (($_POST["command"]!=" --write a command--") && ($_POST["command"]!="" )){
				$v=array();
				$v[] = new xmlrpcval("root", "string");
				$v[] = new xmlrpcval($_POST["command"], "string");  
				$f=new xmlrpcmsg('dsnCommand.dsnCommand', $v);
			}
			else if ($_POST["precommand"]!="--or select a command!--"){
				$v=array();
				$v[] = new xmlrpcval("root", "string"); 
				$v[] = new xmlrpcval($_POST["precommand"], "string"); 
				$f=new xmlrpcmsg('dsnCommand.dsnCommand', $v);
			}
			
			$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
			$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
			//$c->setDebug(2);
			$r=$c->send($f);
			
			if ($r->faultCode()) {
			  print "An error occurred:<pre>";
			  print "Code: " . htmlspecialchars($r->faultCode()) .
				"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
			}
			else{
				$v = $r->value(); 
			}
		}
		else{
			$f=array();
			$k=0;
			$DSNID_one="";
			for($i=0; $i<$max; $i++) {
				if (isset($_POST["ID".str_replace(":","",$DSNID[$i])])){
					if (($_POST["command"]!=" --write a command--") && ($_POST["command"]!="" )){
						$k++;
						$v1 = new xmlrpcval($DSNID[$i], "string"); 
						$v2 = new xmlrpcval($_POST["command"], "string");  
						$f[$k]=new xmlrpcmsg('dsnCommand.dsnCommand');
						$f[$k]->addParam($v1);
						$f[$k]->addParam($v2);
						$DSNID_one = $DSNID[$i]; //is used if there is only one DSN Addr selected
					}
					else if ($_POST["precommand"]!="--or select a command!--"){
						$k++;
						$v1 = new xmlrpcval($DSNID[$i], "string"); 
						$v2 = new xmlrpcval($_POST["precommand"], "string");  
						$f[$k]=new xmlrpcmsg('dsnCommand.dsnCommand');
						$f[$k]->addParam($v1);
						$f[$k]->addParam($v2);
						$DSNID_one = $DSNID[$i]; //is used if there is only one DSN Addr selected						
					}
				}
			}
			if ($k==1){
				if (($_POST["command"]!=" --write a command--") && ($_POST["command"]!="" )){
					$v=array();
					$v[] = new xmlrpcval($DSNID_one, "string"); 
					$v[] = new xmlrpcval($_POST["command"], "string");  
					$f=new xmlrpcmsg('dsnCommand.dsnCommand',$v);
				}
				else if ($_POST["precommand"]!="--or select a command!--"){
					$v=array();
					$v[] = new xmlrpcval($DSNID_one, "string"); 
					$v[] = new xmlrpcval($_POST["precommand"], "string"); 
					$f=new xmlrpcmsg('dsnCommand.dsnCommand',$v);
				}
			}
			$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
			$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
			//$c->setDebug(2);
			$r=&$c->send($f);
			//$r=$c->send($f);
			if ($k < 1){
				for($i=1; $i<=$k; $i++) {
					if ($r[$i]->faultCode()) {
						display_error($r[$i]);
					}
				}
			}else if ($k==1){
				if ($r->faultCode()) {
				  print "An error occurred:<pre>";
				  print "Code: " . htmlspecialchars($r->faultCode()) .
					"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
				}
			}
		}
	}

	if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["DSNCommand"])){
		print'
		<script language="JavaScript">
			function clearField(fld) {
			  if (fld.value == " --write a command--") fld.value = "";
			}
		</script>
		<br><hr/>
		Send a command to a BTnode.
		<br>';
		print'
		<form method="post" action="'.$_SERVER['PHP_SELF'].'?act=DSNCommand">';
		print '<table>';
				print '<tr><td colspan="2">' .
				'<input name="command" type="text" value=" --write a command--" size="20" onClick="clearField(this);"><br>' .
				'<select name="precommand">' .
				' <option>--or select a command!--</option>' .
				' <option>blink</option>' .
				' <option>reset</option>' .
				' <option>dsn get power</option>' .
				' <option>cdist run</option>' .
				'</select>';			
		print'
			<input type="hidden" name="_send_command" value="1">
			&nbsp;<input type="submit" value="send" />
		  </td></tr>';				
		print '<tr><td><input name="all" type="checkbox" value="all" ' .
				'onclick="';
				for($i=0; $i<$max; $i++) {
					print 'this.form.ID'.str_replace(":","",$DSNID[$i]).'.checked = false; ';					
				}
				print'this.form.GUInode.checked = false;"';if (isset($_POST["all"])){print ' checked';}print'> </td><td>all</td></tr>';
		print '<tr><td><input name="GUInode" type="checkbox" value="root" '; if (isset($_POST["GUInode"])){print 'checked';}print' onclick="' .
				'this.form.all.checked = false;';
				for($i=0; $i<$max; $i++) {
					print 'this.form.ID'.str_replace(":","",$DSNID[$i]).'.checked = false; ';					
				}
				print'"></td><td>GUI node </td></tr>';
		for($i=0; $i<$max; $i++) {
			print '<tr><td><input name="ID'.str_replace(":","",$DSNID[$i]).'" type="checkbox" value="'.$DSNID[$i].'" onclick="this.form.all.checked = false;this.form.GUInode.checked = false;"'; if (isset($_POST["ID".str_replace(":","",$DSNID[$i])])){print 'checked';}print'></td><td> '.$DSNID[$i].' </td></tr>';
		}

		print'
		</table>
		</form>
		<hr/>';
	}
}	

?>
