<?php
include "properties.php";

function showimg(){
	list ($width_img, $height_img, $type, $attr) = getimagesize("Bild.jpg");
	$radius = $GLOBALS['radius'];
	$width_real = $GLOBALS['width_real'];
	$height_real = $GLOBALS['height_real'];
	$coninfoUpdate = $GLOBALS['coninfoUpdate'];
	$offset_x = $GLOBALS['offset_x'];
	$offset_y = $GLOBALS['offset_y'];
	
	$DSNIDtoNum = array();
	$v=array();
	$v[] = new xmlrpcval();
	
	// draw the DSNLocation into the image
	// XmlRpc Server
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	// XmlRpc Function
	$f=new xmlrpcmsg('getDSN.getDSN');
	// send request
	$r=&$c->send($f);
	
	// check response for errors, and take appropriate action
	// draw the dots into the image
	if (!$r->faultCode()) {
	  $v=$r->value();
	  $max=$v->arraysize();
	  for($i=0; $i<$max; $i++) {
			// change the data from the XmlRpc-Request into new vars
			$rec=$v->arraymem($i);
			$DSNID_temp		  = $rec->structmem("DSNID");
			$DSNID[$i] 		  = $DSNID_temp->scalarval();
			$DSNVer_temp	  = $rec->structmem("DSNVer");
			$DSNVer[$i] 	  = $DSNVer_temp->scalarval();
			$DSNLocation_temp = $rec->structmem("DSNLocation");
			$DSNLocation[$i]  = $DSNLocation_temp->scalarval();
			$DSNProgInfo_temp = $rec->structmem("DSNProgInfo");
			$DSNProgInfo[$i]  = $DSNProgInfo_temp->scalarval();
			$DSNlastSeen_temp = $rec->structmem("DSNlastSeen");
			$DSNlastSeen[$i]  = $DSNlastSeen_temp->scalarval();
			// a hashtable to indicate the DSNId to the number $i (is used for drawing the conection arrows)
			$DSNIDtoNum[$DSNID[$i]] = $i;
			// parse the location string (xxx/yyy/zzz is espected)
			$firstbackslash = strpos($DSNLocation[$i],"/");
			if ($firstbackslash != false) {$lastbackslash = strpos($DSNLocation[$i],"/",$firstbackslash+1);}
			if (($firstbackslash != false)&&($lastbackslash != false)) {$DSNLocation_x[$i] = substr($DSNLocation[$i], 0,$firstbackslash);$location[$i] = true;} else{$DSNLocation_x[$i] = 0;$location[$i] = false;}
			if (($firstbackslash != false)&&($lastbackslash != false)) {$DSNLocation_y[$i] = substr($DSNLocation[$i], $firstbackslash+1,$lastbackslash-($firstbackslash+1));;} else{$DSNLocation_y[$i] = 0;}
			if (($firstbackslash != false)&&($lastbackslash != false)) {$DSNLocation_z[$i] = substr($DSNLocation[$i], $lastbackslash+1, strlen($DSNLocation[$i])-($lastbackslash+1));;} else{$DSNLocation_z[$i] = 0;}
	
	  }
	} else {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}
	
	// XmlRpc Function
	$coninfoUpdate = 60;
	$time_from = date('Y-m-d H:i:s',time()-$coninfoUpdate);
	$time_till = date('Y-m-d H:i:s');
	
	$f2=new xmlrpcmsg('getConinfo.getConinfo');
		$f2->addParam(new xmlrpcval("all"));
		$f2->addParam(new xmlrpcval("all"));
		$f2->addParam(new xmlrpcval("2"));
		$f2->addParam(new xmlrpcval((string)$time_from));
		$f2->addParam(new xmlrpcval((string)$time_till));
	
	// send request
	$r2=&$c->send($f2);
	
	// check response for errors, and take appropriate action
	if (!$r2->faultCode()) {
	  $v2=$r2->value();
	  $max_2=$v2->arraysize();
	  for($i=0; $i<$max_2; $i++) {
			$rec=$v2->arraymem($i);
			$SourceAddr   		= $rec->structmem("SourceAddr");
			$SourceAddr_2[$i]	= $SourceAddr->scalarval();
			$NeighborAddr 		= $rec->structmem("NeighborAddr");
			$NeighborAddr_2[$i]	= $NeighborAddr->scalarval();
	  }
	} else {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}
	
	$f3=new xmlrpcmsg('getConinfo.getConinfo');
		$f3->addParam(new xmlrpcval("all"));
		$f3->addParam(new xmlrpcval("all"));
		$f3->addParam(new xmlrpcval("1"));
		$f3->addParam(new xmlrpcval((string)$time_from));
		$f3->addParam(new xmlrpcval((string)$time_till));
	
	// send request
	$r3=&$c->send($f3);
	
	// check response for errors, and take appropriate action
	if (!$r3->faultCode()) {
	  $v3=$r3->value();
	  $max_1=$v3->arraysize();
	  for($i=0; $i<$max_1; $i++) {
			$rec=$v3->arraymem($i);
			$SourceAddr   			= $rec->structmem("SourceAddr");
			$SourceAddr_1[$i] 		= $SourceAddr->scalarval();
			$NeighborAddr 			= $rec->structmem("NeighborAddr");
			$NeighborAddr_1[$i]		= $NeighborAddr->scalarval();
	  }
	} else {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}
	print'
	<script type="text/javascript">
	Menu = {timer : null, current : null};
	Menu.getStyle = function(name){
		if(document.getElementById) return document.getElementById(name).style;
		else if(document.all) return document.all[name].style;
		else if(document.layers) return document.layers[name];
	}
	Menu.show = function(name){
		if(this.timer) clearTimeout(this.timer);
		this.getStyle(name).visibility = "visible";
		this.current = name;
	}
	Menu.hide = function(){
		this.timer = setTimeout("Menu.doHide()",300);
	}
	Menu.doHide = function(){
		if(this.current){
			this.getStyle(this.current).visibility = "hidden";
			this.current = null;
		}
	}
	</script>';
		
	for($i=0; $i<$max; $i++) {
		if ($location[$i]){
			print'
				<div id="subnav'.$i.'" style="position:absolute; left:'.(ceil($DSNLocation_x[$i] * ($width_img / $width_real)) + 3 + $radius + $offset_x).'px; top:'.(ceil($DSNLocation_y[$i] * ($height_img / $height_real)) + 18 + $radius + $offset_y).'px; z-index:1000; visibility:hidden;" onmouseover="Menu.show(this.id);" onmouseout="Menu.hide();">
					<layer onmouseover="if(document.layers)Menu.show(\'subnav'.$i.'\');" onmouseout="if(document.layers)Menu.hide();">
						<table class="img">
							<tr>
								<th>ID:&nbsp; </th>
								<td>'.$DSNID[$i].'</td>
							</tr>
							<tr>
								<th>Version:&nbsp; </th>
								<td>'.$DSNVer[$i].'</td>
							</tr>
							<tr>
								<th>Location:&nbsp; </th>
								<td>'.$DSNLocation[$i].'</td>
							</tr>
							<tr>
								<th>Program Info:&nbsp; </th>
								<td>'.$DSNProgInfo[$i].'</td>
							</tr>
							<tr>
								<th>Last Seen:&nbsp; </th>
								<td>'.$DSNlastSeen[$i].'</td>
							</tr>
							<tr>
								<th>Master of:&nbsp; </th>
								<td>';
								for ($j=0; $j<$max_1; $j++){
									if ($DSNID[$i] == $SourceAddr_1[$j]){
										print $NeighborAddr_1[$j]."<br>";
									}
								}
								print'
								</td>
							</tr>
							<tr>
								<th>Slave of:&nbsp; </th>
								<td>';
								for ($j=0; $j<$max_2; $j++){
									if ($DSNID[$i] == $SourceAddr_2[$j]){
										print $NeighborAddr_2[$j]."<br>";
									}
								}
								print'
								</td>
							</tr>
						</table>
					</layer>
				</div>
			';
		}
	}
	
	print'
	<map name="menu">';
	for($i=0; $i<$max; $i++) {
		print'<area shape=rect coords="'.(ceil($DSNLocation_x[$i] * ($width_img / $width_real))-5).','.(ceil($DSNLocation_y[$i] * ($height_img / $height_real))-5).','.(ceil($DSNLocation_x[$i] * ($width_img / $width_real))+5).','.(ceil($DSNLocation_y[$i] * ($height_img / $height_real))+5).'" onmouseover="Menu.doHide(); Menu.show(\'subnav'.$i.'\');" onmouseout="Menu.hide();" onfocus="blur();"></area>
		';
	}
	print'</map>';
}
?>
