<?php 
include "properties.php";

// default values
$form = array(
	'dsnid'		=> 'all',
	'timefrom'  => '0000-00-00 00:00:00',
	'timetil'   => '9999-12-31 00:00:00',
	'class'     => '0',
	'levelmask' => '31',
	'logtext'   => '',
	'order'		=> '0 - DBtime',
	'ascdesc'   => 'desc',
	'start'   	=> '0',
	'maxReply'  => '10');
	

if(isset($_POST['_send_test'])){
	foreach($_POST as $key => $value){
		$form[$key] = htmlentities($_POST[$key]);
	}
//		header ("Content-Type: application/vnd.ms-excel");
//		header("Expires: 0");
//		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
//		header("content-disposition: attachment;filename==yourFileName.xls");
 
	show_form();
	show_log();
}
else{
	show_form();
}



function show_form(){
$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
$u=array();
$u[] = new xmlrpcval("1", "int");

$f=new xmlrpcmsg('getDSN.getDSN',$u);// send request
$r=&$c->send($f);

// check response for errors, and take appropriate action
// draw the dots into the image
if (!$r->faultCode()) {
  $v=$r->value();
  $max=$v->arraysize();
  for($i=0; $i<$max; $i++) {
  		// change the data from the XmlRpc-Request into new vars
		$rec=$v->arraymem($i);
		$DSNID_temp		  = $rec->structmem("DSNID");
		$DSNID[$i] 		  = $DSNID_temp->scalarval();
  }
} else {
  print "An error occurred:<pre>";
  print "Code: " . htmlspecialchars($r->faultCode()) .
    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
}

?>
<hr/>
<form name="getDBEvent" method="post" action="<?php echo $_SERVER['PHP_SELF']."?act=GetDBEvent";?>">
<table> 
<tr><td>DSNID:</td><td>	<select name="dsnid">
	  <option><?php echo $GLOBALS['form']['dsnid'];?></option>
	  <option>all</option>
<?php
for($i=0; $i<$max; $i++) {
	print '	  <option>'.$DSNID[$i].'</option>';
}
?>
	</select>
</td></tr>
<tr><td>timefrom:</td><td><input type="text" name="timefrom" value="<?php echo $GLOBALS['form']['timefrom'];?>"/></td></tr>
<tr><td>timetill:</td><td><input type="text" name="timetil" value="<?php echo $GLOBALS['form']['timetil'];?>"/></td></tr>
<tr><td>class:</td><td><input type="text" name="class" value="<?php echo $GLOBALS['form']['class'];?>"/></td></tr>
<tr><td>levelmask:</td><td><input type="text" name="levelmask" value="<?php echo $GLOBALS['form']['levelmask'];?>"/></td></tr>
<tr><td>logtext:</td><td><input type="text" name="logtext" value="<?php echo $GLOBALS['form']['logtext'];?>"/></td></tr>
<tr><td>order:</td><td>
	<select name="order">
	  <option><?php echo $GLOBALS['form']['order'];?></option>
	  <option>0 - DBtime</option>
	  <option>1 - DSNID</option>
	  <option>2 - MsgID, DSNID</option>
	  <option>3 - DSNtime, DSNID</option>
	  <option>4 - time, DSNtime, DSNID</option>
	  <option>5 - Class, DBtime</option>
	  <option>6 - Level, DBtime</option>
	  <option>7 - text, DBtime, DSNID</option>
	</select>
</td></tr>
<tr><td>asc/desc:</td><td>
	<select name="ascdesc">
	  <option><?php echo $GLOBALS['form']['ascdesc'];?></option>
	  <option>asc</option>
	  <option>desc</option>
	</select>
</td></tr>
<tr><td>start:</td><td><input type="text" name="start" value="<?php echo $GLOBALS['form']['start'];?>"/></td></tr>
<tr><td>maxReply:</td><td>
	<select name="maxReply">
	  <option><?php echo $GLOBALS['form']['maxReply'];?></option>
	  <option>10</option>
	  <option>20</option>
	  <option>50</option>
	  <option>100</option>
	  <option>200</option>
	  <option>500</option>
	  <option>1000</option>
	</select>
</td></tr>
</table>
<input type="submit" value="get log">
<input type="hidden" name="_send_test" value="1">
</form>
<hr/>
<?php

}


function show_log(){
	// create client and message objects
	$v=array();
	$v[] = new xmlrpcval($GLOBALS['form']['dsnid'], "string"); // dsnid
	$v[] = new xmlrpcval($GLOBALS['form']['levelmask'], "int"); // levelmask
	$v[] = new xmlrpcval($GLOBALS['form']['class'], "int");  // logclasses
	$v[] = new xmlrpcval($GLOBALS['form']['logtext'], "string");  // logtext
	$v[] = new xmlrpcval($GLOBALS['form']['timefrom'], "string");  // timefrom
	$v[] = new xmlrpcval($GLOBALS['form']['timetil'], "string");  // timetil
	$v[] = new xmlrpcval(substr($GLOBALS['form']['order'],0,1), "int");  // order
	$v[] = new xmlrpcval($GLOBALS['form']['ascdesc'], "string");  // ascdesc
	$v[] = new xmlrpcval($GLOBALS['form']['start'], "int");  // start
	$v[] = new xmlrpcval($GLOBALS['form']['maxReply'], "int");  // maxReply

	
	$f=new xmlrpcmsg('getDBEvent.getDBEvent',  $v);
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	//$c->setDebug(2);

	// send request
	//print "<hr/><pre>".htmlentities($f->serialize())."</pre><hr/>\n";
	
	$r=&$c->send($f); 
	
	//print "<hr/><pre>".htmlentities($r->serialize())."</pre><hr/>\n";
	
	if ($r->faultCode()) {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
	    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}
	else{
		$v = $r->value(); // array
		$max = $v->arraysize();
		if($max == 0){
			print "no logs found.\n";
			return;
		}
	?>
<style type="text/css">
	@import "getdbevent.css";
</style>

<script language="JavaScript" type="text/javascript">
<!--
function sendform_l ()
{
  document.getDBEvent.start.value = parseInt(document.getDBEvent.start.value) - parseInt(document.getDBEvent.maxReply.value) ;
  document.getDBEvent.submit() ;
}
function sendform_r ()
{
  document.getDBEvent.start.value = parseInt(document.getDBEvent.start.value) + parseInt(document.getDBEvent.maxReply.value) ;
  document.getDBEvent.submit() ;
}
-->
</script>
	  <table class="log">
	<?php
	print'
		<tr>
	      <td colspan="8">';if($GLOBALS['form']['maxReply']<=$max){print'<span style="float:right;"><a href="javascript:sendform_r()">>></a></span>';}if($GLOBALS['form']['start']-$GLOBALS['form']['maxReply']>=0){print'<a href="javascript:sendform_l()"><<</a>';}  print'</td>
	    </tr>  	

	    <tr>
	      <th>DSNID</th><th>ID</th><th>DSNTime</th><th>time</th><th>Class</th><th>Level</th><th>DBTime</th><th>Text</th>
	    </tr>';  	

		for($i=0; $i < $max; $i++){
			$rec = $v->arraymem($i); // struct
			$id_temp = $rec->structmem("MsgID");
			$id = $id_temp->scalarval();
			$dsnid_temp = $rec->structmem("DSNID");
			$dsnid = $dsnid_temp->scalarval();
			$dsntime_temp = $rec->structmem("DSNtime");
			$dsntime = $dsntime_temp->scalarval();
			$time_temp = $rec->structmem("time");
			$time = $time_temp->scalarval();
			$class_temp = $rec->structmem("Class");
			$class = $class_temp->scalarval();
			$level_temp = $rec->structmem("Level");
			$level = $level_temp->scalarval();
			$dbtime_temp = $rec->structmem("DBtime");
			$dbtime = $dbtime_temp->scalarval();
			$text_temp = $rec->structmem("LogText");
			$text = $text_temp->scalarval();
			print "<tr><td>".htmlspecialchars($dsnid).
			      "</td><td>".htmlspecialchars($id).
			      "</td><td>".htmlspecialchars($dsntime).
			      "</td><td>".htmlspecialchars($time).
	              "</td><td>".htmlspecialchars($class).
	              "</td><td>".htmlspecialchars($level).
	              "</td><td>".htmlspecialchars($dbtime).
	              "</td><td>".htmlspecialchars($text).
			      "</td></tr>\n";
		}
		print "</table>\n";
	}
}
?>
