<?php

setverbosity();

function setverbosity(){
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	//$c->setDebug(2);

	$u=array();
	$u[] = new xmlrpcval("1", "int");

	$f=new xmlrpcmsg('getDSN.getDSN',$u);
	// send request
	$r=&$c->send($f);
	
	// check response for errors, and take appropriate action
	// draw the dots into the image
	if (!$r->faultCode()) {
	  $v=$r->value();
	  $max=$v->arraysize();
	  for($i=0; $i<$max; $i++) {
	  		// change the data from the XmlRpc-Request into new vars
			$rec=$v->arraymem($i);
			$DSNID_temp		  = $rec->structmem("DSNID");
			$DSNID[$i] 		  = $DSNID_temp->scalarval();
	  }
	} else {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
	    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}

	if (isset($_POST["_send_verbosity"])){
		// create client and message objects
		$levelmask=0;
		if (isset($_POST["Error"])){$levelmask=$levelmask+$_POST["Error"];}
		if (isset($_POST["Warning"])){$levelmask=$levelmask+$_POST["Warning"];}
		if (isset($_POST["Info"])){$levelmask=$levelmask+$_POST["Info"];}
		if (isset($_POST["Debug"])){$levelmask=$levelmask+$_POST["Debug"];}
		if (isset($_POST["Reply"])){$levelmask=$levelmask+$_POST["Reply"];}
		$v=array();
		
		$v[] = new xmlrpcval($_POST["dsnid"], "string"); 
		$v[] = new xmlrpcval($_POST["class"], "int"); 
		$v[] = new xmlrpcval($levelmask, "int"); 
	
		$f=new xmlrpcmsg('dsnVerbosity.dsnVerbosity',  $v);
		$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
		$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
		//$c->setDebug(2);
		
		// send request
		//print "<hr/><pre>".htmlentities($f->serialize())."</pre><hr/>\n";
		
		$r=&$c->send($f); 
		
		//print "<hr/><pre>".htmlentities($r->serialize())."</pre><hr/>\n";
		
		if ($r->faultCode()) {
		  print "An error occurred:<pre>";
		  print "Code: " . htmlspecialchars($r->faultCode()) .
			"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
		}
	}

	print'
	<hr/>
	<form method="post" action="'.$_SERVER["PHP_SELF"].'?act=SetVerbosity";">
	<table> 
	<tr><td>DSNID:</td><td>	<select name="dsnid">';
		if (isset($_POST["_send_verbosity"])){print'<option>'.$_POST['dsnid'].'</option>';}
		print' <option>all</option>';
	for($i=0; $i<$max; $i++) {
		print '	  <option>'.$DSNID[$i].'</option>';
	}	
	print'
	</select>
	</td></tr>
	<tr><td>Class:</td><td><input type="text" name="class" '; if (isset($_POST["_send_verbosity"])){print'value="'.$_POST['class'].'"';} print' /></td></tr>
	<tr><td>Level:</td><td>
	<input name="Error" type="checkbox" value="1" '; if (isset($_POST["Error"])){print 'checked';}print'>&nbsp;Error&nbsp;&nbsp;&nbsp;
	<input name="Warning" type="checkbox" value="2" '; if (isset($_POST["Warning"])){print 'checked';}print'>&nbsp;Warning&nbsp;&nbsp;&nbsp;
	<input name="Info" type="checkbox" value="4" '; if (isset($_POST["Info"])){print 'checked';}print'>&nbsp;Info&nbsp;&nbsp;&nbsp;
	<input name="Debug" type="checkbox" value="8" '; if (isset($_POST["Debug"])){print 'checked';}print'>&nbsp;Debug&nbsp;&nbsp;&nbsp;
	<input name="Reply" type="checkbox" value="16" '; if (isset($_POST["Reply"])){print 'checked';}print'>&nbsp;Reply&nbsp;&nbsp;&nbsp;
</td></tr>
	</table>
	<input type="submit" value="set verbosity">
	<input type="hidden" name="_send_verbosity" value="1">
	</form>
	<hr/>';
}
?>
