<?php
include("properties.php");

dsncommand_command();
dsncommand_ping();


function dsncommand_command(){
	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
	
	$u=array();
	$u[] = new xmlrpcval("1", "int");

	$f=new xmlrpcmsg('getDSN.getDSN',$u);
	// send request
	$r=&$c->send($f);
	
	if (!$r->faultCode()) {
	  $v=$r->value();
	  $max=$v->arraysize();
	  for($i=0; $i<$max; $i++) {
			// change the data from the XmlRpc-Request into new vars
			$rec=$v->arraymem($i);
			$DSNID_temp		  = $rec->structmem("DSNID");
			$DSNID[$i] 		  = $DSNID_temp->scalarval();
	  }
	} else {
	  print "An error occurred:<pre>";
	  print "Code: " . htmlspecialchars($r->faultCode()) .
		"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
	}

if(!((isset($_GET['act']) AND ("GetDSN" == $_GET['act'])))){ 
	if(isset($_POST['_send_command_l'])){
		if (($_POST["command"]!=" --write a command--") && ($_POST["command"]!="" )){
			$v=array();
			$v[] = new xmlrpcval($_POST["dsnid"], "string");
			$v[] = new xmlrpcval($_POST["command"], "string");  
			$f=new xmlrpcmsg('dsnCommand.dsnCommand', $v);
		}
		else if ($_POST["precommand"]!="--or select a command!--"){
			$v=array();
			$v[] = new xmlrpcval($_POST["dsnid"], "string"); 
			$v[] = new xmlrpcval($_POST["precommand"], "string"); 
			$f=new xmlrpcmsg('dsnCommand.dsnCommand', $v);
		}
		
		$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
		$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
		//$c->setDebug(2);
		$r=$c->send($f);
		
		if ($r->faultCode()) {
		  print "An error occurred:<pre>";
		  print "Code: " . htmlspecialchars($r->faultCode()) .
			"\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
		}
		else{
			$v = $r->value(); 
		}
	}
}
	if ((isset($_SESSION["Username"]))&&($_SESSION["all"]||$_SESSION["DSNCommand"])){
		print'
		<script language="JavaScript">
			function clearField(fld) {
			  if (fld.value == " --write a command--") fld.value = "";
			}
		</script>';
		
		print'
		<hr>
		<form method="post" action="'.$_SERVER['PHP_SELF'].'?act='.$_GET['act'].'">';
		print '<table>';

		print'<tr><td>DSNID:</td></tr>
			  <tr><td><select name="dsnid">
			  			<option>'.$_POST["dsnid"].'</option>
			  			<option>all</option>	
			  			<option>root</option>';					  				
		for($i=0; $i<$max; $i++) {
			print '	    <option>'.$DSNID[$i].'</option>';
		}
		print'
				  </select>
			  </td></tr>';
		
		print '<tr><td>command:</td></tr>
				<tr><td>' .
				'<input name="command" type="text" value=" --write a command--" size="20" onClick="clearField(this);"><br>' .
				'<select name="precommand">' .
				' <option>--or select a command!--</option>' .
				' <option>blink</option>' .
				' <option>reset</option>' .
				' <option>dsn get power</option>' .
				' <option>cdist run</option>' .
				'</select>';			
		print'
			<input type="hidden" name="_send_command_l" value="1">
			<input type="submit" value="send" />
		  </td></tr>';				

		print'
		</table>
		</form>
		<hr/>';
	}
}	

function dsncommand_ping(){
if(!((isset($_GET['act']) AND ("GetDSN" == $_GET['act'])))){ 
	if(isset($_POST['send_dsnping_l'])){sendping_l("dsn ping");}
	if(isset($_POST['send_dsnversionping_l'])){sendping_l("dsn get version");}
	if(isset($_POST['send_dsnlocationping_l'])){sendping_l("dsn get loc");}
	if(isset($_POST['send_dsnproginfoping_l'])){sendping_l("xbank get proginfo");}
	if(isset($_POST['send_coninfo_l'])){sendping_l("coninfo","root");}
}
	print'
	<table> 
	<tr>
		<td>
			<form method="post" action="'.$_SERVER['PHP_SELF'].'?act='.$_GET['act'].'">
				<input type="submit" value="send dsnping">
				<input type="hidden" name="send_dsnping_l" value="1">				
			</form>
		</td>
	</tr>
	<tr>
		<td>
			<form method="post" action="'.$_SERVER['PHP_SELF'].'?act='.$_GET['act'].'">
				<input type="submit" value="send dsnVersionPing">
				<input type="hidden" name="send_dsnversionping_l" value="1">				
			</form>
		</td>
	</tr>
	<tr>
		<td>
			<form method="post" action="'.$_SERVER['PHP_SELF'].'?act='.$_GET['act'].'">
				<input type="submit" value="send dsnLocationPing">
				<input type="hidden" name="send_dsnlocationping_l" value="1">				
			</form>
		</td>
	</tr>
	<tr>
		<td>
			<form method="post" action="'.$_SERVER['PHP_SELF'].'?act='.$_GET['act'].'">
				<input type="submit" value="send dsnProgInfoPing">
				<input type="hidden" name="send_dsnproginfoping_l" value="1">				
			</form>
		</td>
	</tr>
	<tr>
		<td>
			<form method="post" action="'.$_SERVER['PHP_SELF'].'?act='.$_GET['act'].'">
				<input type="submit" value="send coninfo">
				<input type="hidden" name="send_coninfo_l" value="1">				
			</form>
		</td>
	</tr>
	<!--
	<tr>
		<td>
			<form method="post" action="'.$_SERVER['PHP_SELF'].'?act='.$_GET['act'].'">
				<input type="submit" value="send JawsTime">
				<input type="hidden" name="send_jawstime_l" value="1">				
			</form>
		</td>
	</tr>
	-->
	<tr>
		<td></td>
	</tr>
	
	</table>
	
	<hr/>';
}	


//function execute_l($thread, $state){
//	$v=array();
//	$v[] = new xmlrpcval($thread, "string"); 
//	$v[] = new xmlrpcval($state, "string"); 
//
//	$f=new xmlrpcmsg('threadSwitch.threadSwitch',  $v);
//	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
//	$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
//	//$c->setDebug(2);
//	
//	$r=&$c->send($f); 
//	if ($r->faultCode()) {
//	  print "An error occurred:<pre>";
//	  print "Code: " . htmlspecialchars($r->faultCode()) .
//	    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
//	}
//
//}
//
//function sendping_l($string, $destination = 'all'){
//	$v=array();
//	$v[] = new xmlrpcval($destination, "string"); 
//	$v[] = new xmlrpcval($string, "string"); 
//
//	$f=new xmlrpcmsg('dsnCommand.dsnCommand',  $v);
//	$c=new xmlrpc_client("/", $GLOBALS['host'], $GLOBALS['port']);
//	$c->setCredentials($_SESSION["Username"], $_SESSION["pwd"]);
//	//$c->setDebug(2);
//	
//	$r=&$c->send($f); 
//	if ($r->faultCode()) {
//	  print "An error occurred:<pre>";
//	  print "Code: " . htmlspecialchars($r->faultCode()) .
//	    "\nReason: '" . htmlspecialchars($r->faultString()).'\'</pre><hr/>';
//	}	
//}


?>
